---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------
---------------------Addon Constants and variables-------------
---------------------Addon Constants and variables-------------
---------------------Addon Constants and variables-------------
---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------



local STC_Version="2.5";


SuperTC_Options = {
	["enable"] = true,
	["auto"] = 1,
	["debug"]= 0,
	["warrior"] = 1,
	["combat"] = 1,
};


SuperTC_Abilities = {
	["TC"] = 1,
	["Demo"] = 1,
	["Battle"] = 1,
	["Rend"] = 1,
	["Hamstring"] = 1,
	["Sunder"] = 1,
};


local SuperTC_Events={
	"CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE",		--Mobs afflicted by TC
	"CHAT_MSG_SPELL_SELF_DAMAGE",				--You TC hits/Demo resist
	"UNIT_SPELLCAST_SUCCEEDED",				--When casting a spell(Demo/TC)
	"PLAYER_TARGET_CHANGED",
	"PLAYER_REGEN_ENABLED",
};


SuperTC_Setting = {
	["mob"] = "",
};


--Keeping track of bar positions
local STC_Bars = {0,0,0,0,0,0};
local STC_Positions = {0,0,0,0,0,0};


--Default timers
local SuperTC_TC_Time=30;
local SuperTC_Demo_Time=30;
local SuperTC_Shout_Time=120;
local SuperTC_Rend_Time=21;
local SuperTC_Hamstring_Time=15;
local SuperTC_Sunder_Time=30;


--Time when ability was used
local SuperTC_StartTime=0;
local SuperTC_StartTime2=0;
local SuperTC_StartTime3=0;
local SuperTC_StartTime4=0;
local SuperTC_StartTime5=0;
local SuperTC_StartTime6=0;


--Fading constants
local SuperTC_Start_Fade=0;
local SuperTC_Total_Fade=6;
local SuperTC_Fade_Time=7;


--Update timers
local STC_Movetime=0;
local STC_TimeSinceLastUpdate=0;
local STC_TimeSinceLastUpdate2=0;
local STC_TimeSinceLastUpdate3=0;
local STC_TimeSinceLastUpdate4=0;
local STC_TimeSinceLastUpdate5=0;
local STC_TimeSinceLastUpdate6=0;


local STC_UpdateInterval=0.1;
local STC_UpdateInterval2=0.1;
local STC_UpdateInterval3=0.3;
local STC_UpdateInterval4=0.05;
local STC_UpdateInterval5=0.05;
local STC_UpdateInterval6=0.1;


--Active flags
local SuperTC_Active=0;
local SuperTC_Active2=0;
local SuperTC_Active3=0;
local SuperTC_Active4=0;
local SuperTC_Active5=0;
local SuperTC_Active6=0;


--Demoshout variables
local STC_Democast=0;
local STC_Demoiscast=0;
local STC_Demoresist=0;

--Rend variables
local STC_Rendcast=0;
local STC_Rendiscast=0;
local STC_Rendresist=0;

--Sunder variables
local STC_Sundercast=0;
local STC_Sunderiscast=0;
local STC_Sunderresist=0;
local STC_Sunderon=0;

local STC_Demospell="Demoralizing Shout";
local STC_Shoutspell="Battle Shout";







---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------
---------------------On load and defaults----------------------
---------------------On load and defaults----------------------
---------------------On load and defaults----------------------
---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------



function SuperTC_OnLoad()

	SLASH_SuperTC1 = "/supertc";
	SlashCmdList["SuperTC"] = SuperTC_SlashHandler;

	SuperTC_Print("SuperTC version "..STC_Version.." loaded. Developed by SuperCommander");
	SuperTC_Print("/supertc for options [on, off, move, set mob, auto, ability, combat, reset, settings, debug]");
 
	SuperTC_Frame:RegisterEvent("VARIABLES_LOADED");
	
end



function SuperTC_Reset()
	SuperTC_Options = {
		["enable"] = true,
		["auto"] = 1,
		["debug"]= 0,
		["warrior"] = 1,
		["combat"] = 1,
	};

	SuperTC_Abilities = {
		["TC"] = 1,
		["Demo"] = 1,
		["Battle"] = 1,
		["Rend"] = 1,
		["Hamstring"] = 1,
		["Sunder"] = 1,
	};

	SuperTC_Setting = {
		["mob"] = "",
	};

	SuperTC_Active=0;
	SuperTC_Active2=0;
	SuperTC_Active3=0;
	SuperTC_Active4=0;
	SuperTC_Active5=0;
	SuperTC_Active6=0;

	STC_Bars = {0,0,0,0,0,0};
	STC_Positions = {0,0,0,0,0,0};

	SuperTC_Hide();
	SuperTC_Hide2();
	SuperTC_Hide3();
	SuperTC_Hide4();
	SuperTC_Hide5();
	SuperTC_Hide6();

	SuperTC_Anchor:SetPoint("TOPLEFT", "UIParent", "CENTER", -50, 50);
	SuperTC_OnEvent("VARIABLES_LOADED");
	SuperTC_Print("Restoring defaults");
end







---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------
-----------------Slashcommands and registering events----------
-----------------Slashcommands and registering events----------
-----------------Slashcommands and registering events----------
---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------



--Slashcommands
function SuperTC_SlashHandler(msg)

	if (string.lower(msg)=="off") then 
		SuperTC_Print("SuperTC is now disabled");
		SuperTC_Unregister();
		SuperTC_Options.enable=false;
		SuperTC_Hide();
		SuperTC_Hide2();
		SuperTC_Hide3();
		SuperTC_Hide4();
		SuperTC_Hide5();
		SuperTC_Hide6();

	elseif (string.lower(msg)=="on") then 
		SuperTC_Print("SuperTC is now enabled");
		SuperTC_Register();
		SuperTC_Options.enable=true;
		SuperTC_Reset();
		SuperTC_Hide();
		SuperTC_Hide2();
		SuperTC_Hide3();
		SuperTC_Hide4();
		SuperTC_Hide5();
		SuperTC_Hide6();

	elseif (string.lower(msg)=="move") then 
		SuperTC_Print("You can now move the bars around by dragging the 'Move me'-bar. It is visible for 10seconds.");
		SuperTC_Move();

	elseif (string.lower(msg)=="settings") then
		SuperTC_Print_Settings();

	elseif (string.lower(msg)=="debug") then
		SuperTC_Debug();

	elseif (string.lower(msg)=="reset") then
		SuperTC_Reset();

	elseif (string.lower(msg)=="auto") then
		SuperTC_Auto();

	elseif (string.lower(msg)=="combat") then
		SuperTC_Combat();

	elseif (string.lower(string.sub(msg,1,7)) == "set mob") then
		SuperTC_Set_Mob(string.sub(msg,9));

	elseif (string.lower(string.sub(msg,1,7)) == "ability") then
		SuperTC_Ability_Toggle(string.sub(msg,9));

	else
		SuperTC_Print("/superTC on/off/set mob/move/auto/ability/combat/reset/settings/debug");
	end
end



--Register events(Enable mod)
function SuperTC_Register()
	
	for index, value in pairs(SuperTC_Events) do
		SuperTC_Frame:RegisterEvent(value);
	end	
end



--Unregister events(Disable mod)
function SuperTC_Unregister()
	for index, value in pairs(SuperTC_Events) do
		SuperTC_Frame:UnregisterEvent(value);
	end	
end







---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------
---------------------Setting mob and toggle functions----------
---------------------Setting mob and toggle functions----------
---------------------Setting mob and toggle functions----------
---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------



--Setting mob(With slashcommand)
function SuperTC_Set_Mob(SuperTC_Mob_New)
	
	if (SuperTC_Mob_New~="") then
		SuperTC_Setting.mob=string.lower(SuperTC_Mob_New);
	elseif (UnitExists("target")) then
		SuperTC_Setting.mob=string.lower(UnitName("target"));
	else
		SuperTC_Setting.mob="";
	end
	SuperTC_Print("Mob set to "..SuperTC_Setting.mob);
end



--Automatically setting mob
function SuperTC_Set_Mob_Auto()
	
	if (UnitExists("target")) and (UnitIsEnemy("target", "player")) then
		SuperTC_Setting.mob=string.lower(UnitName("target"));

		--Due to odd behaviour of string.find and "-"
		if string.find(SuperTC_Setting.mob,"-") then
			
			local temp=nil;		
			
			temp=string.find(SuperTC_Setting.mob,"-");
			
			if (temp~=1) then
				SuperTC_Setting.mob=string.sub(SuperTC_Setting.mob,1,temp);
			end
		end

		--Debug
		if (SuperTC_Options.debug==1) then
			SuperTC_Print_Debug("Mob set automatically to "..SuperTC_Setting.mob);
		end
	end
end



--Toggle autofunction
function SuperTC_Auto()
	
	if (SuperTC_Options.auto==1) then
		SuperTC_Options.auto=0;
		SuperTC_Print("Automatic mode disabled");
	elseif (SuperTC_Options.auto==0) then
		SuperTC_Options.auto=1;
		SuperTC_Print("Automatic mode enabled");
	end
end


--Toggle combatfade
function SuperTC_Combat()
	
	if (SuperTC_Options.combat==1) then
		SuperTC_Options.combat=0;
		SuperTC_Print("Now letting bars stay after combat");
	elseif (SuperTC_Options.combat==0) then
		SuperTC_Options.combat=1;
		SuperTC_Print("Hiding bars when combat ends");
	end
end


--Toggle debug mode
function SuperTC_Debug()
	
	if (SuperTC_Options.debug==1) then
		SuperTC_Options.debug=0;
		SuperTC_Print("Debug mode disabled");
	elseif (SuperTC_Options.debug==0) then
		SuperTC_Options.debug=1;
		SuperTC_Print("Debug mode enabled");
	end
end


--Turning of the reports of the ability SuperTC_Abilities[Making sure the skill exists and then calling STC_Ability_Toggle()]
function SuperTC_Ability_Toggle(STC_Ability)

	local STC_Temp_Ability=nil;
	local STC_Enabled=nil;

	for STC_Temp_Ability, STC_Enabled in pairs(SuperTC_Abilities) do
		
		if string.lower(STC_Temp_Ability)==string.lower(STC_Ability) then
			STC_Ability_Change(STC_Temp_Ability);
		end
	end		
end


--Helpfunction for STC_Ability_Toggle
function STC_Ability_Change(STC_Ability)
	
	if SuperTC_Abilities[STC_Ability]==1 then
		SuperTC_Abilities[STC_Ability]=0;
		SuperTC_Print("No longer showing bar for '"..STC_Ability.."'");

	elseif SuperTC_Abilities[STC_Ability]==0 then
		SuperTC_Abilities[STC_Ability]=1;
		SuperTC_Print("Now showing bar for '"..STC_Ability.."'");
	end

end







---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------
---------------------Misc functions----------------------------
---------------------Misc functions----------------------------
---------------------Misc functions----------------------------
---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------



--Formatting timers
function SuperTC_Time(seconds)
	local time;
	local h,m,s;
	local text="";

	if (seconds==nil) then
		return text;
	end

	time=seconds;
	
	if( time <= 0 ) then
		return text;
	else
		h=floor(time/3600);
		time=time-h*3600;

		m=floor(time/60);
		time=time-m*60;

		s=floor(time);
	end

	if h>0 then
		text=h.."."
		if m<10 then
			text=text.."0"..m;
		else
			text=text..m;
		end
	else
		text=m..":";
		if s<10 then
			text=text.."0"..s;
		else
			text=text..s;
		end
	end

	return text;
end







---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------
---------------------Report functions--------------------------
---------------------Report functions--------------------------
---------------------Report functions--------------------------
---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------



--Reporting messages
function SuperTC_Print(msg)
	DEFAULT_CHAT_FRAME:AddMessage("[SuperTC]: "..msg,1,0.7,0);
end



--Printing debug messages
function SuperTC_Print_Debug(msg)
	DEFAULT_CHAT_FRAME:AddMessage("[SuperTC](Debug): "..msg,1,0.7,0);
end



--Lists settings
function SuperTC_Print_Settings()

	SuperTC_Print("Mob: "..SuperTC_Setting.mob);

	if (SuperTC_Options.debug==1) then
		SuperTC_Print("Thunderclap timer lenght: "..SuperTC_TC_Time.." seconds");
		SuperTC_Print("Demoshout timer lenght: "..SuperTC_Demo_Time.." seconds");
	end	

	if (SuperTC_Options.auto==1) then
		SuperTC_Print("Automatic mode enabled");
	elseif  (SuperTC_Options.auto==0) then
		SuperTC_Print("Automatic mode disabled")
	end

	local STC_Temp_Ability=nil;
	local STC_Enabled=nil;

	SuperTC_Print("List of skills SuperTC supports:");

	for STC_Temp_Ability, STC_Enabled in pairs(SuperTC_Abilities) do

		if STC_Enabled==1 then
			SuperTC_Print(STC_Temp_Ability.." enabled");
		else
			SuperTC_Print(STC_Temp_Ability.." disabled");
		end
	end	

end







---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------
---------------------Moving the bars---------------------------
---------------------Moving the bars---------------------------
---------------------Moving the bars---------------------------
---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------


function SuperTC_Move()
	SuperTC_Anchor:Show();
end



function SuperTC_Move_Time(Elapsed)
	STC_Movetime = STC_Movetime+Elapsed;
	if (STC_Movetime>10) then
		SuperTC_Anchor_Hide();
		STC_Movetime=0;
	end
end







---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------
---------------------Generating timer--------------------------
---------------------Generating timer--------------------------
---------------------Generating timer--------------------------
---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------



--Get the first empty location
function STC_Get_Empty_Pos(STC_Bar)
	local i=nil;
	for i=1,6 do
		if STC_Bars[i]==0 then
			STC_Bars[i]=1;
			STC_Positions[STC_Bar]=i;
			return i;
		end
	end
end


--Free up the spot the bar just used
function STC_Set_Empty_Pos(STC_Bar)
	STC_Bars[STC_Positions[STC_Bar]]=0;
end


--Setting the position
function SuperTC_New_Timer(TC_Ability)

	if (TC_Ability==1) then
		SuperTC_Frame:SetPoint("TOPLEFT", "SuperTC_Anchor", "TOPLEFT", 0, -14*STC_Get_Empty_Pos(1));
	elseif (TC_Ability==2) then
		SuperTC_Frame2:SetPoint("TOPLEFT", "SuperTC_Anchor", "TOPLEFT", 0, -14*STC_Get_Empty_Pos(2));
	elseif (TC_Ability==3) then
		SuperTC_Frame3:SetPoint("TOPLEFT", "SuperTC_Anchor", "TOPLEFT", 0, -14*STC_Get_Empty_Pos(3));
	elseif (TC_Ability==4) then
		SuperTC_Frame4:SetPoint("TOPLEFT", "SuperTC_Anchor", "TOPLEFT", 0, -14*STC_Get_Empty_Pos(4));
	elseif (TC_Ability==5) then
		SuperTC_Frame5:SetPoint("TOPLEFT", "SuperTC_Anchor", "TOPLEFT", 0, -14*STC_Get_Empty_Pos(5));
	elseif (TC_Ability==6) then
		SuperTC_Frame6:SetPoint("TOPLEFT", "SuperTC_Anchor", "TOPLEFT", 0, -14*STC_Get_Empty_Pos(6));

	end
end


--Starting the Thunder Clap timer
function SuperTC_Start_Timer()

	if (SuperTC_Abilities.TC==0) then
		return;
	end

	if (SuperTC_Active==0) then
		SuperTC_Active=1;
		SuperTC_New_Timer(1);
	end

	local STC_Val=0;
	local STC_X=190/2*(STC_Val-50)/50;
	local STC_Time=SuperTC_Time(SuperTC_TC_Time);

	SuperTC_StartTime=GetTime();

	SuperTC_Frame:Show();
	SuperTC_Frame:SetAlpha(1);
	SuperTC_Bar:SetValue(STC_Val);
	SuperTC_Background:Show();
	SuperTC_Spark:SetPoint("CENTER",STC_X,0);
	SuperTC_Spark:Show();
	SuperTC_Text:SetText("Thunderclap");
	SuperTC_Timer:SetText(STC_Time);
	
end



--Starting Demoshout timer
function SuperTC_Start_Timer2()

	if (SuperTC_Abilities.Demo==0) then
		return;
	end

	if (SuperTC_Active2==0) then
		SuperTC_Active2=1;
		SuperTC_New_Timer(2);
	end

	local STC_Val=0;
	local STC_X=190/2*(STC_Val-50)/50;
	local STC_Time=SuperTC_Time(SuperTC_Demo_Time);

	SuperTC_StartTime2=GetTime();

	SuperTC_Frame2:Show();
	SuperTC_Frame2:SetAlpha(1);
	SuperTC_Bar2:SetValue(STC_Val);
	SuperTC_Background2:Show();
	SuperTC_Spark2:SetPoint("CENTER",STC_X,0);
	SuperTC_Spark2:Show();
	SuperTC_Text2:SetText(STC_Demospell);
	SuperTC_Timer2:SetText(STC_Time);
	
end



--Starting Battle/Commandingshout timer
function SuperTC_Start_Timer3()

	if (SuperTC_Abilities.Battle==0) then
		return;
	end

	if (SuperTC_Active3==0) then
		SuperTC_Active3=1;
		SuperTC_New_Timer(3);
	end

	local STC_Val=0;
	local STC_X=190/2*(STC_Val-50)/50;
	local STC_Time=SuperTC_Time(SuperTC_Shout_Time);

	SuperTC_StartTime3=GetTime();

	SuperTC_Frame3:Show();
	SuperTC_Frame3:SetAlpha(1);
	SuperTC_Bar3:SetValue(STC_Val);
	SuperTC_Background3:Show();
	SuperTC_Spark3:SetPoint("CENTER",STC_X,0);
	SuperTC_Spark3:Show();
	SuperTC_Text3:SetText(STC_Shoutspell);
	SuperTC_Timer3:SetText(STC_Time);
	
end


--Starting Rend timer
function SuperTC_Start_Timer4()

	if (SuperTC_Abilities.Rend==0) then
		return;
	end

	if (SuperTC_Active4==0) then
		SuperTC_Active4=1;
		SuperTC_New_Timer(4);
	end

	local STC_Val=0;
	local STC_X=190/2*(STC_Val-50)/50;
	local STC_Time=SuperTC_Time(SuperTC_Rend_Time);

	SuperTC_StartTime4=GetTime();

	SuperTC_Frame4:Show();
	SuperTC_Frame4:SetAlpha(1);
	SuperTC_Bar4:SetValue(STC_Val);
	SuperTC_Background4:Show();
	SuperTC_Spark4:SetPoint("CENTER",STC_X,0);
	SuperTC_Spark4:Show();
	SuperTC_Text4:SetText("Rend");
	SuperTC_Timer4:SetText(STC_Time);
	
end


--Starting Hamstring timer
function SuperTC_Start_Timer5()

	if (SuperTC_Abilities.Hamstring==0) then
		return;
	end

	if (SuperTC_Active5==0) then
		SuperTC_Active5=1;
		SuperTC_New_Timer(5);
	end

	local STC_Val=0;
	local STC_X=190/2*(STC_Val-50)/50;
	local STC_Time=SuperTC_Time(SuperTC_Hamstring_Time);

	SuperTC_StartTime5=GetTime();

	SuperTC_Frame5:Show();
	SuperTC_Frame5:SetAlpha(1);
	SuperTC_Bar5:SetValue(STC_Val);
	SuperTC_Background5:Show();
	SuperTC_Spark5:SetPoint("CENTER",STC_X,0);
	SuperTC_Spark5:Show();
	SuperTC_Text5:SetText("Hamstring");
	SuperTC_Timer5:SetText(STC_Time);
	
end


--Starting Sunder timer
function SuperTC_Start_Timer6()

	if (SuperTC_Abilities.Sunder==0) then
		return;
	end

	STC_Sunderon=1;

	if (SuperTC_Active6==0) then
		SuperTC_Active6=1;
		SuperTC_New_Timer(6);
	end

	local STC_Val=0;
	local STC_X=190/2*(STC_Val-50)/50;
	local STC_Time=SuperTC_Time(SuperTC_Sunder_Time);

	SuperTC_StartTime6=GetTime();

	SuperTC_Frame6:Show();
	SuperTC_Frame6:SetAlpha(1);
	SuperTC_Bar6:SetValue(STC_Val);
	SuperTC_Background6:Show();
	SuperTC_Spark6:SetPoint("CENTER",STC_X,0);
	SuperTC_Spark6:Show();
	SuperTC_Text6:SetText("Sunder Armor");
	SuperTC_Timer6:SetText(STC_Time);
	
end




---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------
-----------------------Update functions------------------------
-----------------------Update functions------------------------
-----------------------Update functions------------------------
---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------



--Thunder Clap update
function SuperTC_Update_Timer(Elapsed)		

	if (SuperTC_Active==1) then
		STC_TimeSinceLastUpdate = STC_TimeSinceLastUpdate+Elapsed;


		if (STC_TimeSinceLastUpdate>STC_UpdateInterval) then

			local STC_Time=nil;
			local STC_Elapsed=GetTime()-SuperTC_StartTime;
			local STC_Val=100*STC_Elapsed/SuperTC_TC_Time;
			local STC_X=190/2*(STC_Val-50)/50;

			if (SuperTC_TC_Time-STC_Elapsed<0) then
				SuperTC_Fade(STC_Elapsed-SuperTC_TC_Time);
			else
				STC_Time=SuperTC_Time(SuperTC_TC_Time-STC_Elapsed+1);
				SuperTC_Bar:SetValue(STC_Val);
				SuperTC_Spark:SetPoint("CENTER",STC_X,0);
				SuperTC_Timer:SetText(STC_Time);
			end	
		STC_TimeSinceLastUpdate=STC_TimeSinceLastUpdate-STC_UpdateInterval;
		end
	end
end


--Demoshout update
function SuperTC_Update_Timer2(Elapsed)
	
	if (STC_Demoiscast==1) and (GetTime()-STC_Democast>0.05) then
		if (STC_Demoresist==0) then
			SuperTC_Start_Timer2();
			STC_Demoiscast=0;
		elseif (STC_Demoresist==1) then
			STC_Demoresist=0;
			STC_Demoiscast=0;
		end	
	end

	--Demoshout
	if (SuperTC_Active2==1) then
		STC_TimeSinceLastUpdate2 = STC_TimeSinceLastUpdate2+Elapsed;


		if (STC_TimeSinceLastUpdate2>STC_UpdateInterval2) then

			local STC_Time=nil;
			local STC_Elapsed=GetTime()-SuperTC_StartTime2;
			local STC_Val=100*STC_Elapsed/SuperTC_Demo_Time;
			local STC_X=190/2*(STC_Val-50)/50;

			if (SuperTC_Demo_Time-STC_Elapsed<0) then
				SuperTC_Fade2(STC_Elapsed-SuperTC_Demo_Time);
			else
				STC_Time=SuperTC_Time(SuperTC_Demo_Time-STC_Elapsed+1);
				
				SuperTC_Bar2:SetValue(STC_Val);
				SuperTC_Spark2:SetPoint("CENTER",STC_X,0);
				SuperTC_Timer2:SetText(STC_Time);
			end
	
		STC_TimeSinceLastUpdate2=STC_TimeSinceLastUpdate2-STC_UpdateInterval2;
		end
	end
end


--Battle/Commanding Shout update
function SuperTC_Update_Timer3(Elapsed)	

	if (SuperTC_Active3==1) then
		STC_TimeSinceLastUpdate3 = STC_TimeSinceLastUpdate3+Elapsed;


		if (STC_TimeSinceLastUpdate3>STC_UpdateInterval3) then

			local STC_Time=nil;
			local STC_Elapsed=GetTime()-SuperTC_StartTime3;
			local STC_Val=100*STC_Elapsed/SuperTC_Shout_Time;
			local STC_X=190/2*(STC_Val-50)/50;

			if (SuperTC_Shout_Time-STC_Elapsed<0) then
				SuperTC_Fade3(STC_Elapsed-SuperTC_Shout_Time);
			else
				STC_Time=SuperTC_Time(SuperTC_Shout_Time-STC_Elapsed+1);
				
				SuperTC_Bar3:SetValue(STC_Val);
				SuperTC_Spark3:SetPoint("CENTER",STC_X,0);
				SuperTC_Timer3:SetText(STC_Time);
			end
	
		STC_TimeSinceLastUpdate3=STC_TimeSinceLastUpdate3-STC_UpdateInterval3;
		end
	end
end


--Rend update
function SuperTC_Update_Timer4(Elapsed)
	
	if (STC_Rendiscast==1) and (GetTime()-STC_Rendcast>0.05) then
		if (STC_Rendresist==0) then
			SuperTC_Start_Timer4()
			STC_Rendiscast=0;
		elseif (STC_Rendresist==1) then
			STC_Rendresist=0;
			STC_Rendiscast=0;
		end	
	end

	--Demoshout
	if (SuperTC_Active4==1) then
		STC_TimeSinceLastUpdate4 = STC_TimeSinceLastUpdate4+Elapsed;


		if (STC_TimeSinceLastUpdate4>STC_UpdateInterval4) then

			local STC_Time=nil;
			local STC_Elapsed=GetTime()-SuperTC_StartTime4;
			local STC_Val=100*STC_Elapsed/SuperTC_Rend_Time;
			local STC_X=190/2*(STC_Val-50)/50;

			if (SuperTC_Rend_Time-STC_Elapsed<0) then
				SuperTC_Fade4(STC_Elapsed-SuperTC_Rend_Time);
			else
				STC_Time=SuperTC_Time(SuperTC_Rend_Time-STC_Elapsed+1);
				
				SuperTC_Bar4:SetValue(STC_Val);
				SuperTC_Spark4:SetPoint("CENTER",STC_X,0);
				SuperTC_Timer4:SetText(STC_Time);
			end
	
		STC_TimeSinceLastUpdate4=STC_TimeSinceLastUpdate4-STC_UpdateInterval4;
		end
	end
end


--Hamstring
function SuperTC_Update_Timer5(Elapsed)
	if (SuperTC_Active5==1) then
		STC_TimeSinceLastUpdate5 = STC_TimeSinceLastUpdate5+Elapsed;


		if (STC_TimeSinceLastUpdate5>STC_UpdateInterval5) then

			local STC_Time=nil;
			local STC_Elapsed=GetTime()-SuperTC_StartTime5;
			local STC_Val=100*STC_Elapsed/SuperTC_Hamstring_Time;
			local STC_X=190/2*(STC_Val-50)/50;

			if (SuperTC_Hamstring_Time-STC_Elapsed<0) then
				SuperTC_Fade5(STC_Elapsed-SuperTC_Hamstring_Time);
			else
				STC_Time=SuperTC_Time(SuperTC_Hamstring_Time-STC_Elapsed+1);
				
				SuperTC_Bar5:SetValue(STC_Val);
				SuperTC_Spark5:SetPoint("CENTER",STC_X,0);
				SuperTC_Timer5:SetText(STC_Time);
			end
	
		STC_TimeSinceLastUpdate5=STC_TimeSinceLastUpdate5-STC_UpdateInterval5;
		end
	end
end


--Sunder update
function SuperTC_Update_Timer6(Elapsed)
	
	if (STC_Sunderiscast==1) and (GetTime()-STC_Sundercast>0.05) then
		if (STC_Sunderresist==0) then
			SuperTC_Start_Timer6();
			STC_Sunderiscast=0;
		elseif (STC_Sunderresist==1) then
			STC_Sunderresist=0;
			STC_Sunderiscast=0;
		end	
	end

	if (SuperTC_Active6==1) then
		STC_TimeSinceLastUpdate6 = STC_TimeSinceLastUpdate6+Elapsed;


		if (STC_TimeSinceLastUpdate6>STC_UpdateInterval6) then

			local STC_Time=nil;
			local STC_Elapsed=GetTime()-SuperTC_StartTime6;
			local STC_Val=100*STC_Elapsed/SuperTC_Sunder_Time;
			local STC_X=190/2*(STC_Val-50)/50;

			if (SuperTC_Sunder_Time-STC_Elapsed<0) then
				SuperTC_Fade6(STC_Elapsed-SuperTC_Sunder_Time);
			else
				STC_Time=SuperTC_Time(SuperTC_Sunder_Time-STC_Elapsed+1);
				
				SuperTC_Bar6:SetValue(STC_Val);
				SuperTC_Spark6:SetPoint("CENTER",STC_X,0);
				SuperTC_Timer6:SetText(STC_Time);
			end
	
		STC_TimeSinceLastUpdate6=STC_TimeSinceLastUpdate6-STC_UpdateInterval6;
		end
	end
end







---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------
-----------------------Fading functions------------------------
-----------------------Fading functions------------------------
-----------------------Fading functions------------------------
---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------



--Fading the Thunderclap bar
function SuperTC_Fade(Overtime)

	local STC_Time=nil;
	local SuperTC_Alpha=1-(Overtime-SuperTC_Start_Fade)/SuperTC_Fade_Time;

	STC_Time="-"..SuperTC_Time(Overtime);	
	
	if (Overtime>SuperTC_Total_Fade) then
		SuperTC_Active=0;
		STC_Set_Empty_Pos(1);
		SuperTC_Hide();
		return;
	elseif (Overtime>SuperTC_Start_Fade) then
		SuperTC_Frame:SetAlpha(SuperTC_Alpha)
	end
	
	SuperTC_Bar:SetValue(100);		
	SuperTC_Spark:Hide();
	SuperTC_Timer:SetText(STC_Time);
	
end



--Fading the Demoshout bar
function SuperTC_Fade2(Overtime)

	local STC_Time=nil;
	local SuperTC_Alpha=1-(Overtime-SuperTC_Start_Fade)/SuperTC_Fade_Time;

	STC_Time="-"..SuperTC_Time(Overtime);	
	
	if (Overtime>SuperTC_Total_Fade) then
		SuperTC_Active2=0;
		STC_Set_Empty_Pos(2);
		SuperTC_Hide2();
		return;
	elseif (Overtime>SuperTC_Start_Fade) then
		SuperTC_Frame2:SetAlpha(SuperTC_Alpha)
	end
	
	SuperTC_Bar2:SetValue(100);		
	SuperTC_Spark2:Hide();
	SuperTC_Timer2:SetText(STC_Time);
	
end



--Fading the Battle/Commandingshout bar
function SuperTC_Fade3(Overtime)

	local STC_Time=nil;
	local SuperTC_Alpha=1-(Overtime-SuperTC_Start_Fade)/SuperTC_Fade_Time;

	STC_Time="-"..SuperTC_Time(Overtime);	
	
	if (Overtime>SuperTC_Total_Fade) then
		SuperTC_Active3=0;
		STC_Set_Empty_Pos(3);
		SuperTC_Hide3();
		return;
	elseif (Overtime>SuperTC_Start_Fade) then
		SuperTC_Frame3:SetAlpha(SuperTC_Alpha)
	end
	
	SuperTC_Bar3:SetValue(100);		
	SuperTC_Spark3:Hide();
	SuperTC_Timer3:SetText(STC_Time);
	
end


--Fading the Rend bar
function SuperTC_Fade4(Overtime)

	local STC_Time=nil;
	local SuperTC_Alpha=1-(Overtime-SuperTC_Start_Fade)/SuperTC_Fade_Time;

	STC_Time="-"..SuperTC_Time(Overtime);	
	
	if (Overtime>SuperTC_Total_Fade) then
		SuperTC_Active4=0;
		STC_Set_Empty_Pos(4);
		SuperTC_Hide4();
		return;
	elseif (Overtime>SuperTC_Start_Fade) then
		SuperTC_Frame4:SetAlpha(SuperTC_Alpha)
	end
	
	SuperTC_Bar4:SetValue(100);		
	SuperTC_Spark4:Hide();
	SuperTC_Timer4:SetText(STC_Time);
	
end


--Fading hamstring bar
function SuperTC_Fade5(Overtime)

	local STC_Time=nil;
	local SuperTC_Alpha=1-(Overtime-SuperTC_Start_Fade)/SuperTC_Fade_Time;

	STC_Time="-"..SuperTC_Time(Overtime);	
	
	if (Overtime>SuperTC_Total_Fade) then
		SuperTC_Active5=0;
		STC_Set_Empty_Pos(5);
		SuperTC_Hide5();
		return;
	elseif (Overtime>SuperTC_Start_Fade) then
		SuperTC_Frame5:SetAlpha(SuperTC_Alpha)
	end
	
	SuperTC_Bar5:SetValue(100);		
	SuperTC_Spark5:Hide();
	SuperTC_Timer5:SetText(STC_Time);
	
end


--Fading the Sunder bar
function SuperTC_Fade6(Overtime)

	STC_Sunderon=0;

	local STC_Time=nil;
	local SuperTC_Alpha=1-(Overtime-SuperTC_Start_Fade)/SuperTC_Fade_Time;

	STC_Time="-"..SuperTC_Time(Overtime);	
	
	if (Overtime>SuperTC_Total_Fade) then
		SuperTC_Active6=0;
		STC_Set_Empty_Pos(6);
		SuperTC_Hide6();
		return;
	elseif (Overtime>SuperTC_Start_Fade) then
		SuperTC_Frame6:SetAlpha(SuperTC_Alpha)
	end
	
	SuperTC_Bar6:SetValue(100);		
	SuperTC_Spark6:Hide();
	SuperTC_Timer6:SetText(STC_Time);
	
end







---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------
-----------------------Main event handler----------------------
-----------------------Main event handler----------------------
-----------------------Main event handler----------------------
---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------



function SuperTC_OnEvent(event)

	if ( event == "VARIABLES_LOADED") then
		SuperTC_Anchor_Hide();
		SuperTC_Hide();
		SuperTC_Hide2();
		SuperTC_Hide3();
		SuperTC_Hide4();
		SuperTC_Hide5();
		SuperTC_Hide6();

		--Setting class
		if (UnitClass("player")=="Warrior") then
			
			if (SuperTC_Options.enable) then
				SuperTC_Register();
			
				SuperTC_Options.warrior=1;
				
				--Correct time on demoshout
				local nameTalent, icon, tier, column, currRank, maxRank= GetTalentInfo(2,1);
				SuperTC_Demo_Time=30+currRank*3;

				--Correct time on Battle/Commandingshout
				local nameTalent, icon, tier, column, currRank, maxRank= GetTalentInfo(1,1);
				SuperTC_Shout_Time=120+currRank*12;

				--Setting Demospell
				STC_Demospell="Demoralizing Shout";
			end

		--Druid
		elseif (UnitClass("player")=="Druid") then
			if (SuperTC_Options.enable) then
				SuperTC_Register();
			
				SuperTC_Options.warrior=0;
				
				--Correct time on demoroar
				SuperTC_Demo_Time=30;

				--Setting Demospell
				STC_Demospell="Demoralizing Roar";
			end
		else
			return;
		end
		return;
	end


	if (event=="PLAYER_REGEN_ENABLED") then
		if (SuperTC_Options.combat==1) then

			if (SuperTC_Active==1) then
				SuperTC_Active=0;
				STC_Set_Empty_Pos(1);
				SuperTC_Hide();
			end

			if (SuperTC_Active2==1) then
				SuperTC_Active2=0;
				STC_Set_Empty_Pos(2);
				SuperTC_Hide2();
			end

			if (SuperTC_Active4==1) then
				SuperTC_Active4=0;
				STC_Set_Empty_Pos(4);
				SuperTC_Hide4();
			end

			if (SuperTC_Active5==1) then
				SuperTC_Active5=0;
				STC_Set_Empty_Pos(5);
				SuperTC_Hide5();
			end

			if (SuperTC_Active6==1) then
				SuperTC_Active6=0;
				STC_Set_Empty_Pos(6);
				SuperTC_Hide6();
			end
		end
		return;
	end


	if (event=="UNIT_SPELLCAST_SUCCEEDED") and (arg1=="player") then
		if (arg2==STC_Demospell) then
			STC_Democast=GetTime();
			STC_Demoiscast=1;
		elseif (arg2=="Rend") then
			STC_Rendcast=GetTime();
			STC_Rendiscast=1;
		elseif (arg2=="Sunder Armor") then
			STC_Sundercast=GetTime();
			STC_Sunderiscast=1;
		elseif (arg2=="Battle Shout") then
			STC_Shoutspell="Battle Shout";
			SuperTC_Start_Timer3();
		elseif (arg2=="Commanding Shout") then
			STC_Shoutspell="Commanding Shout";
			SuperTC_Start_Timer3();
		end
		return;
	elseif (event=="PLAYER_TARGET_CHANGED") then
		if (SuperTC_Options.auto==1) then
			SuperTC_Set_Mob_Auto();
		end
		return;
	end


	local SuperTC_Event=string.lower(arg1);
	
	if string.find(SuperTC_Event, SuperTC_Setting.mob) then
		if string.find(SuperTC_Event, string.lower("is afflicted by "..STC_Demospell)) then
			SuperTC_Start_Timer2();
		elseif string.find(SuperTC_Event, string.lower("your "..STC_Demospell.." was resisted by")) then
			STC_Demoresist=1;

		--Warrior only part
		elseif (SuperTC_Options.warrior==1) then
			--Thunderclap
			if string.find(SuperTC_Event, "is afflicted by thunder clap") or string.find(SuperTC_Event,"your thunder clap hits") then
				SuperTC_Start_Timer();
			--Hamstring
			elseif string.find(SuperTC_Event, "is afflicted by hamstring") or string.find(SuperTC_Event,"your hamstring hits") then
				SuperTC_Start_Timer5();
			--Devastate
			elseif string.find(SuperTC_Event,"your devastate hits") and (STC_Sunderon==1) then
				SuperTC_Start_Timer6();
			--Rend
			elseif string.find(SuperTC_Event, "is afflicted by rend") then
				SuperTC_Start_Timer4();
			elseif string.find(SuperTC_Event, string.lower("your rend was ")) or string.find(SuperTC_Event, string.lower("your rend missed ")) then
				STC_Rendresist=1;
			--Sunder
			elseif string.find(SuperTC_Event, "is afflicted by sunder armor") then
				SuperTC_Start_Timer6();
			elseif string.find(SuperTC_Event, string.lower("your sunder armor was ")) or string.find(SuperTC_Event, string.lower("your sunder armor missed ")) then
				STC_Sunderresist=1;
			end
		end
	end
end







---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------
-----------------------Hide function---------------------------
-----------------------Hide function---------------------------
-----------------------Hide function---------------------------
---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------



--Hiding Anchor
function SuperTC_Anchor_Hide()
	SuperTC_Anchor:Hide();
	SuperTC_Anchor_Bar:SetValue(100);
	SuperTC_Anchor_Text:SetText("Move me");
end


--Hiding Thunderclap bar
function SuperTC_Hide()
	SuperTC_Frame:Hide();
	SuperTC_Bar:SetValue(0);
	SuperTC_Background:Hide();
	SuperTC_Spark:Hide();
	SuperTC_Text:SetText(nil);
	SuperTC_Timer:SetText(nil);

end



--Hiding Demoshout bar
function SuperTC_Hide2()

	SuperTC_Frame2:Hide();
	SuperTC_Bar2:SetValue(0);
	SuperTC_Background2:Hide();
	SuperTC_Spark2:Hide();
	SuperTC_Text2:SetText(nil);
	SuperTC_Timer2:SetText(nil);
end



--Hiding Battle/Commandingshout bar
function SuperTC_Hide3()

	SuperTC_Frame3:Hide();
	SuperTC_Bar3:SetValue(0);
	SuperTC_Background3:Hide();
	SuperTC_Spark3:Hide();
	SuperTC_Text3:SetText(nil);
	SuperTC_Timer3:SetText(nil);
end


--Hiding Rend
function SuperTC_Hide4()

	SuperTC_Frame4:Hide();
	SuperTC_Bar4:SetValue(0);
	SuperTC_Background4:Hide();
	SuperTC_Spark4:Hide();
	SuperTC_Text4:SetText(nil);
	SuperTC_Timer4:SetText(nil);
end


--Hiding Hamstring
function SuperTC_Hide5()

	SuperTC_Frame5:Hide();
	SuperTC_Bar5:SetValue(0);
	SuperTC_Background5:Hide();
	SuperTC_Spark5:Hide();
	SuperTC_Text5:SetText(nil);
	SuperTC_Timer5:SetText(nil);
end


--Hiding Sunder
function SuperTC_Hide6()

	SuperTC_Frame6:Hide();
	SuperTC_Bar6:SetValue(0);
	SuperTC_Background6:Hide();
	SuperTC_Spark6:Hide();
	SuperTC_Text6:SetText(nil);
	SuperTC_Timer6:SetText(nil);
end